
-- http://xlsxwriterlua.readthedocs.org/example_demo.html#ex-demo

----
--
-- A simple example of some of the features of the xlsxwriter.lua module.
--
-- Copyright 2014-2015, John McNamara, jmcnamara@cpan.org
--

local Workbook = require "xlsxwriter.workbook"

local workbook  = Workbook:new("demo.xlsx")
local worksheet = workbook:add_worksheet()

-- Widen the first column to make the text clearer.
worksheet:set_column("A:B", 20)

-- Add a bold format to use to highlight cells.
local bold = workbook:add_format({bold = true})

-- Write some simple text.
worksheet:write("A1", "Hello")

-- Text with formatting.
worksheet:write("A2", "World", bold)

-- Write some numbers, with row/column notation.
worksheet:write(2, 0, 123)
worksheet:write(3, 0, 123.456)

workbook:close()

--[[
Notes:

This example includes the use of cell formatting via the The Format Class.
Strings and numbers can be written with the same worksheet write() method.
Data can be written to cells using Row-Column notation or ‘A1’ style notation, 
see Working with Cell Notation.

© Copyright 2014-2015, John McNamara.
Created using Sphinx 1.3.1.
]]

--